// Title:  BiDiPro DLL module
// Desc:   Intel Firmware Hub (p)
// Ver:    0.86b
// Found:  22-07-2003
// Last:   17-08-2003
// CPU:    386+
// Model:  Tiny
// Compil: Borland C++ 3.1 (DOS)
// Author: Grisha Lutsenko

// Based on Intel datasheets

#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include "dlldata.h"
#include "errors.h"
#include "bidi.h"

//#define CMDLINE

#ifndef CMDLINE
 #define dlp ((DLLDATA *) NULL)        /* ⥫    */
#else
 extern DLLDATA far * dlp;
#endif //CMDLINE

#define bdport dlp->bdprt            /* 㪠⥫  hardware ࠩ */

#define DataPortIn()  bdport(PFORCE|PWR1|PBIN)
#define DataPortOut() bdport(PFORCE|PWR1)

struct  CHDEFS
{
   dword size;   // 
   byte  dpins;  //   dip 
   byte  rA2;    // ॣ  ⥭ //WE=1,CE=0,OE=0
   byte  rC1;    // use only for 256
   byte  rwB2;   // 殮
   byte  wC1h;   // :
   byte  wC1l;   //
   byte  wA2h;   // WE=1,CE=1,OE=1
   byte  wA2l;   // WE=0,CE=0,OE=1
};

CHDEFS chd[]={
//   size    pins  rA2   rC1  rwB2  wC1h  wC1l  wA2h  wA2l
  {0x080000L, 32, 0x00, 0x00, 0x82, 0x00, 0x00, 0x74, 0x60},  //040
  {0x100000L, 32, 0x00, 0x00, 0x82, 0x00, 0x00, 0x74, 0x60},  //080

};

// ७   CFG:
static struct CFGKEY cfgkeys[]={
{'D', "MaxWT", 50,50},   //max ⥫쭮 ppp        0
{'D', "ErTime",600000,6000000},  //p 横 p             1
{'D', "Reset",1,1,1},      //reset on/off                           2
{0,    NULL,   0,0},     //End of table
};

#define cfg_MaxWT  cfgkeys[0].data
#define cfg_ETime  cfgkeys[1].data
#define cfg_Reset  cfgkeys[2].data

static char* copyright="82802 Intel FirmWare Hub module (c) Grisha Lutsenko ["__DATE__"]";
static word chtype=0xFFFF;           //  ROM
static CHDEFS * pchd;
byte wrbit;

#define power_off breset
inline void set_adr(dword adr);

void breset (void)
{
   bdport (PRST);
}


void write_code (dword adr,byte dat)
{
     set_adr(adr);
     bdport (PWA2 | 0xA8|wrbit);
//     dlp->mcsdelay(2);
     bdport (PWA2 | 0xB8|wrbit);
//     dlp->mcsdelay(2);
     bdport (PWB1 | dat);
//     dlp->mcsdelay(2);
     bdport (PWA2 | 0xBC|wrbit);
}


int power_on (byte mode)
{
   word vmask=pchd->rwB2;

   if (chtype == 0xFFFF) return ERC_CHIPUNSP;

   if (mode=='R')
    {
     DataPortIn();              // DD1:OIO
     bdport (PFORCE|PWR2);      // DD4:OOO
     bdport (PWA2 | 0xBC);      //ce,oe,pe
//⠭ 殮
     dlp->voltage (dlp->Vcc,0,0);
     bdport (PWB2 | (vmask & 0xE0) ); //Vcc pins
    }
   else //'W' or other
    {
     bdport (PFORCE|PWR2);       // DD4:OOO
     bdport (PWA2 | 0xBC);       // ce,oe,pe
     DataPortOut();              // DD1:OOO
//⠭ 殮
//     vmask&=0xE0;             //Vpp disable
     dlp->voltage (dlp->Vcc,dlp->Vpp,0);
     bdport (PWB2 | vmask );    //Vcc on
    }
   dlp->mcsdelay(100000);
   if(cfg_Reset==1)
    {
        bdport(PWA2 | 0);
       dlp->mcsdelay(100);
        bdport(PWA2 | 0xB4);
       dlp->mcsdelay(100);
        bdport(PWA2 | 0xBC|wrbit);
       dlp->mcsdelay(5);
    }

   return 0;
}

int testinsert (void)
{
   if (dlp->testins==0) return 0; // ஢塞
   power_on('R');
   byte d1,d2;
// ⠭  0xFFFFF:
     bdport (PWA1 | 0xFF );
     bdport (PWC1 | pchd->rC1);
     bdport (PWA2 | pchd->rA2 | BITTER | 0x0F); //ter=1
     dlp->mcsdelay(10);             //প
     d1=bdport(PRB1);
     bdport (PWA2 | (pchd->rA2 & ~BITTER | 0x0F)); //ter=0
     dlp->mcsdelay(10);             //প
     d2=bdport(PRB1);
     bdport (PWA2 | pchd->rA2 | BITTER | 0x0F); //ter=1

   if (d1==d2)
        {
     power_off();
     dlp->mcsdelay(3000);
     return 0; //ok
     }

   power_off();
   dlp->msgBox (dmfError|dmfOKButton,"\003Chip not connected!");
   return 1; //error

}


// ⠭ 
inline void set_adr(dword adr)
{
     dword adres;
     adres=adr;
     adr=adres&0x7FF;
     byte db;
//     dlp->mcsdelay(1);
// 1  :
     bdport (PWA1 | (adr&255));
// 2  :
     bdport (PWC1 | ((adr&0x700)>>8) );
//     dlp->mcsdelay(1);
// 3 ᨣ CE=0, OE=1, WE=1:
     bdport (PWA2 | 0xAC|wrbit);
//     dlp->mcsdelay(1);


     adr=(adres&0x3FF800)>>11;
// 1  :
     bdport (PWA1 | (adr&255) );
// 2  :
     bdport (PWC1 | ((adr&0x700)>>8) );
//     dlp->mcsdelay(1);

}

inline byte read_one (dword adr)
{
     byte db;
     set_adr(adr);
// 3 ᨣ CE=1, OE=1, WE=1:
     bdport (PWA2 | 0xBC);
//     dlp->mcsdelay(1);

     bdport (PWA2 | 0x9C);
//     dlp->mcsdelay(1);

// DATA
     db=(byte) bdport(PRB1);
//     dlp->mcsdelay(1);
     bdport (PWA2 |0xBC);

     return db;
}


int read_all (void)
{
   dword adr;
   dword istep=pchd->size/64L;
   if (chtype == 0xFFFF) return ERC_CHIPUNSP;
   if(testinsert()==1) return 0;
   power_on('R');
   for (adr=0;adr<pchd->size;adr++)
    {
      dlp->setbytebuf (adr,read_one(adr));
      if (adr%istep == 0)
       if (dlp->iprogress(adr,2)) break;
    }
   power_off();
   return 0;
}

int write_all (void)
{
   dword adr;
   word r;
   dword istep=pchd->size/64L;
   byte  tdr,db,t;
        dword i;

   if (chtype == 0xFFFF) return ERC_CHIPUNSP;
   if(testinsert()) return 0;
   power_on('W');
   for (adr=0; adr < pchd->size; adr++)
    {
      db=dlp->getbytebuf(adr);
      //⮢ 
      DataPortOut();
      disable();      // 뢠  ६  ࠭
      write_code(adr,0x40);
      write_code(adr,db);
      enable();

        DataPortIn();
        for(i=0;i<cfg_MaxWT;i++)
        {
        dlp->mcsdelay(1);
        bdport(PWA2 | 0x9C|wrbit);
        tdr=(byte) bdport(PRB1);
        if(tdr!=0xFF)
                if(tdr&128) break;
        bdport(PWA2 | 0xBC|wrbit);
        }
        bdport(PWA2 | 0xBC|wrbit);
      if(dlp->checkwr)
        {
        if(tdr&127)
        {
         r = dlp->msgBox(dmfError|dmfOKButton|dmfCancelButton,"Byte Programm Failed at %08lX.\n Code %02X ",adr,tdr);
         write_code(adr,0x50|wrbit);
         write_code(adr,0xD0|wrbit);
         if (r==11) //cmCancel
          break;
        }
        }


     if ((adr+1)%istep == 0)
     if (dlp->iprogress(adr,2)) break;

    }
   power_off();
   return 0;
}

int erase (void)
{
   dword istep=pchd->size/64L;
   dword err=0;
   dword i;
   byte tdr;
   dword adr;
   if (chtype == 0xFFFF) return ERC_CHIPUNSP;
   if(testinsert()) return 0;
   power_on('W');
   dlp->iprogress(pchd->size,0);


   for (adr=1;adr<pchd->size;adr=adr+0x10000)
    {
       DataPortOut();
       write_code(adr,0x20);
        dlp->mcsdelay(10);
       write_code(adr,0xD0);

        DataPortIn();
        for(i=0;i<cfg_ETime;i++)
        {
        dlp->mcsdelay(1);
        bdport(PWA2 | 0x9C|wrbit);
        tdr=(byte) bdport(PRB1);
        if(tdr!=0xFF)
                if(tdr&128) break;
        bdport(PWA2 | 0xBC|wrbit);
        }
        bdport(PWA2 | 0xBC|wrbit);

       if (dlp->iprogress(adr+0x10000,2)) break;

        if(tdr&127)
        {
         dlp->msgBox(dmfError|dmfOKButton,"Block Erase Failed at block %d.\n Code %dx%02X ",(adr/0x10000),tdr,tdr);
         write_code(adr,0x50);
         write_code(adr,0xD0);
        }


    }

   power_off();

   dlp->iprogress(0,1); //close

   if (!tdr) return ERC_BLANK;
   return 0;
}


// Product Identification:
inline int read_id(void)
{
   dword id1,id2;
   dlp->edata=0;
   if (chtype == 0xFFFF) return ERC_CHIPUNSP;
   if(testinsert()) return 0;
   power_on('R');

     DataPortOut();

     disable();      // 뢠  ६ . ०. ⥭ ID
     write_code(0x5555,0x0AA);
     write_code(0x2AAA,0x055);
     write_code(0x5555,0x090);
     enable();
     dlp->mcsdelay(2);

   DataPortIn();               // DD1:OIO
   set_adr(0);
   bdport(PWA2 | 0x9C);
   dlp->mcsdelay(1);
   id1= (byte) bdport(PRB1);
   set_adr(1);
   bdport(PWA2 | 0x9C);
   dlp->mcsdelay(1);
// 
   id2= (byte) bdport(PRB1);
   dlp->edata = id1 | (id2<<16L);
   power_off();
   return 0;
}

// ⠢  ஬
int compare_all(void)
{
   dword adr;
   dword errors=0;
   dword istep=pchd->size/64L;
   if (chtype == 0xFFFF) return ERC_CHIPUNSP;
   if(testinsert()) return 0;
   power_on('R');
   for (adr=0;adr<pchd->size;adr++)
    {
      if (dlp->getbytebuf(adr) != read_one(adr) ) //ࠢ  ஬
       {
         dlp->setbmark(adr,1);  //⬥ ᮢ
         errors++;
       }
      if (adr%istep == 0)
       {
         if (dlp->iprogress(adr,2)) break;
       }
    }
   power_off();
   dlp->edata=errors;
   return 0;
}

int blank_chk(void)
{
   dword adr;
   dword istep=pchd->size/64L;
   if (chtype == 0xFFFF) return ERC_CHIPUNSP;
   if(testinsert()) return 0;
   power_on('R');
   for (adr=0;adr<pchd->size;adr++)
    {
      if (read_one(adr) != 0xFF ) //ࠢ  FF
       {
         dlp->adr=adr;
         power_off();
         return 1;
        }
       if (adr%istep == 0)
        if (dlp->iprogress(adr,2)) break;
    }
   power_off();
   return 0;
}


// ⠭ ⨯ ROM
word settype (void)
{
   for (word i=0;i<sizeof(chd)/sizeof(CHDEFS);i++)
    {
      if (chd[i].size == dlp->esize)
       return chtype=i;
    }
   return chtype=0xFFFF;
}

// main code
extern "C" int dmain(void)
{
   wrbit=0;
   switch (dlp->funcode)
    {
      case DFN_LOAD:
// ⨢஢ 㯭 㭪樨:
       dlp->funmask[DFN_FREAD]=1;
       dlp->funmask[DFN_FWRITE]=1;
       dlp->funmask[DFN_READID]=1;
       dlp->funmask[DFN_ERASE]=1;
       dlp->funmask[DFN_FCOMPARE]=1;
       dlp->funmask[DFN_FBLANK]=1;
       dlp->funmask[DFN_TEST]=0;
       dlp->funmask[DFN_LOCK]=0;
       dlp->funmask[DFN_UNLOCK]=0;
       dlp->defstate=0xFF;
       dlp->copyright=copyright;
       dlp->version=DLLVERSION;
       dlp->cfgkeys=cfgkeys;
       return 0;
      case DFN_INIT:
       if (settype() == 0xFFFF) return ERC_CHIPUNSP;
       pchd=&chd[chtype];
       dlp->dippins=pchd->dpins;
       dlp->Vcc=55;
//       dlp->Vpp=120;
       dlp->Vppmax=120;
       return 0;

      case DFN_FREAD:
       return read_all();

      case DFN_FWRITE:
       wrbit=0x40;
       return write_all();

      case DFN_FCOMPARE:
       return compare_all();

      case DFN_FBLANK:
       return blank_chk();

      case DFN_READID:
       return read_id();

      case DFN_ERASE:
       wrbit=0x40;
       return erase();

      default:
       return ERC_FUNUNSP;
    }
}
